beginStateMachine()

	onEnter(function(msg)
		printSOInfo(this, "onEnter", true);
		
		if exitIfLocked("all") then return end

		--if (App.get().isPixelationSupported()) then
		--	getParent().enableBlend(true);
		--end
		
		setState("sitDown");
	end )

	onExit(function(msg)
		printSOInfo(this, "onExit", true)
		
		--if (App.get().isPixelationSupported()) then
		--	getParent().enableBlend(false);
		--end
		
		unlockAll("toilet");
	end )

	state("sitDown")

		onEnter(function(msg)
			printSOInfo(this, "onEnter")

			local character = getParent();
			local other, result = getDisturbingChar(character, "showNaked");
			if (other) then
				cancelAndExit();
				character.setEmoticon(EMOTICON_SHY, EMOTICON_DELAY);
				--other.sendMsg("emoShameChar", character.walkSO);
				return
			end;

--			startAnimation("sitdownToilet");
			startAnimation(genderize2(getParent(), "sitdownToilet"));
		end )

		onMsg("end", function(msg)
			if testCancel() then
				finishAndExit("standUp");
			else
				cleanExit("standUp");
			end
		end )


	-- sit
	state("sit")

		onEnter(function(msg)
			printSOInfo(this, "onEnter")

			sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			--sendDelayedMsgThis("stink", 5);

			local toilet = get("toilet");
			dirtify(toilet, DIRTIFY_PER_SIT_TOILET);

			local sitToilet = getParent().startActivity("sitToilet", toilet);
			local length, scale = getActivityLength(sitToilet);

			sendDelayedMsgThis("complete", length);
			sendMsgThis("startLoop");

		end )

		onExit(function(msg)
			local toilet = get("toilet");
			getParent().stopActivity("sitToilet", toilet);
		end )

		onMsg("startLoop", function(msg)
			startAnimation(genderize2(getParent(), "sitToilet"));
		end )

		onMsg("stink", function(msg)
			local toilet = get("toilet");
			toilet.setChildEnable("stink", true);
		end )

		onMsg("complete", function(msg)
			cancelAndExit("standUp");
		end )

		onMsg("end", function(msg)
			if testCancel() then
				finishAndExit("standUp");
			else
				sendMsgThis("startLoop");
			end
		end )

		onMsg("testCancel", function(msg)
			if testCancel() then
				finishAndExit("standUp");
			else
				sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			end
		end )

	-- stand up from toilet
	state("standUp")

		onEnter(function(msg)
			startAnimation("standupToilet");
			sendDelayedMsgThis("flushSound", 4.2);
		end )

		onMsg("flushSound", function(msg)
			getParent().playSound("Sfx_ToiletFlush_01");
		end )

		onMsg("end", function(msg)

			local toilet = get("toilet");
			toilet.setChildEnable("stink", false);

			queueFollowActivity("pm_washHands", "washHands", "sink")		

			exitStateMachine();
		end )



endStateMachine()
